#ifndef __3D_FONTLOADER__
#define __3D_FONTLOADER__

#ifdef __cplusplus
extern "C" {
#endif

// SDK includes
#include <psptypes.h>
#include <pspkernel.h>

// Freetype includes
#include "libge.h"
#include <ft2build.h>
#include <freetype/freetype.h>
#include FT_FREETYPE_H

typedef struct
{
	char* name;
	FT_Face face;
	u8* data;
	int pId, pId2;
} ge_Font;

void geFontInitBitmaps(ge_Image** Chars, ge_Font* font, int size);
int gePrintScreenBitmaps(ge_Image** Chars, int x, int y, const char* text, u32 color, u32* framebuffer);
//Experimental
int gePrintScreenBitmapsDirect(ge_Image** Chars, int x, int y, const char* text, u32 color);
//
int gePrintImageBitmaps(ge_Image** Chars, int x, int y, const char* text, Color color, ge_Image* image);
ge_Font* geLoadFont(const char* filename);
ge_Font* geLoadFontPartitionMemory(const char* filename, const char* partitionName);
int geUnloadFont(ge_Font* font);
void geFreeFontPartitionMemory(ge_Font* font);
int geFontSetSizePixels(ge_Font* font, int height);
int geFontPrintScreen(ge_Font* font, int x, int y, const char* text, u32 color, u32* framebuffer);
int geFontPrintScreenUnicode(ge_Font* font, int x, int y, long chr, u32 color, u32* framebuffer);
int geFontPrintScreenInt(ge_Font* font, int x, int y, int numb, u32 color, u32* framebuffer);
int geFontPrintImage(ge_Font* font, int x, int y, const char* text, u32 color, ge_Image* image);

void gePrintSysTextScreen(int x, int y, const char* text, u32 color);
void gePrintSysTextImage(int x, int y, const char* text, u32 color, ge_Image* image);

int geFontWidthOfText(ge_Font* font, const char* text);
int geFontHeightOfText(ge_Font* font, const char* text);
int geFontLinesOfText(const char* text);

#ifdef __cplusplus
}
#endif

#endif
